package
{
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.display.Stage3D;
	import flash.display3D.Context3D;
	import flash.display3D.Context3DRenderMode;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLLoaderDataFormat;
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	import jp.live2d.Live2D;
	import jp.live2d.Live2DModelAs3;
	import jp.live2d.util.UtSystem;
	import flash.utils.ByteArray;
	import mx.utils.StringUtil;

	// mtn 用に追加
	import jp.live2d.motion.Live2DMotion;
	import jp.live2d.motion.MotionQueueManager;

${SWF}
	public class Main extends Sprite
	{
		public var context3D:Context3D;
		public var live2DModel:Live2DModelAs3;

		// mtn 用に追加
		private var motionMgr:MotionQueueManager = new MotionQueueManager;
		private var motions:Array = new Array /*of AMotion*/; // あらかじめ読み込んでおくモーション

${EMBED_VAR_MOC}
${EMBED_VAR_BMP}
${EMBED_VAR_MTN}
${EMBED_VAR_RES}

		public function Main():void
		{
			Live2D.init();
			var stage3D:Stage3D = stage.stage3Ds[0];
			// 3Dレイヤーの準備
			stage3D.addEventListener(Event.CONTEXT3D_CREATE, onCreateStage3D, false, 1);
			stage3D.requestContext3D(Context3DRenderMode.AUTO);
		}
		/*
		 * 3Dレイヤーの準備完了時
		 * @param	event
		 */
		public function onCreateStage3D(e:Event):void		
		{		
			context3D = (e.target as Stage3D).context3D;
			context3D.configureBackBuffer(stage.stageWidth, stage.stageHeight, 0, false);
			context3D.setRenderToBackBuffer();

			// グラフィックコンテキストをモデルに設定
${EMBED_CODE_MOC}
			live2DModel.setGraphicsContext(context3D);

			// 表示位置の設定	
			var scale:Number = 2 / live2DModel.getCanvasWidth(); // 横幅で合わせる	
			live2DModel.scaleX = scale;	
			live2DModel.scaleY = -scale;	
			live2DModel.x = -1; // スクリーン上の左上とモデルの左上を合わせる	
			live2DModel.y = 1;	

			// テクスチャの設定
${EMBED_CODE_BMP}

			// モーションの設定
${EMBED_CODE_MTN}

			// [参考]リソースの設定
${EMBED_CODE_RES}

			stage.addEventListener(Event.ENTER_FRAME, update);	
		}

		public function update(e:Event):void
		{
			// 実行モーション番号をランドマイズ
			var max:int = motions.length;
			var no:int = Math.random() * max;
			
			// 画面のクリア
			context3D.clear(1, 1, 1, 0);

			// 待機モーション判定
			if (motionMgr.isFinished()) 
			{
				// モーションの再生がない場合、待機モーションの中からランダムで再生する
				motionMgr.startMotion(motions[no]);
			}
			// モーションの更新
			motionMgr.updateParam(live2DModel);
			// モデルパラメータの更新
			live2DModel.update();
			// モデル描画
			live2DModel.draw(); 
			// 描画を適用
			context3D.present(); 
		}
	}
}